diff --git a/external/fmt/test/ranges-test.cc b/external/fmt/test/ranges-test.cc
index 46208e8d..63cb8c8b 100644
--- a/external/fmt/test/ranges-test.cc
+++ b/external/fmt/test/ranges-test.cc
@@ -11,106 +11,109 @@
 
 #include "fmt/ranges.h"
 
-#include "gtest.h"
+#include <map>
+#include <string>
+#include <vector>
 
-// Check if  'if constexpr' is supported.
-#if (__cplusplus > 201402L) || \
-    (defined(_MSVC_LANG) && _MSVC_LANG > 201402L && _MSC_VER >= 1910)
+#include "gtest/gtest.h"
 
-#  include <array>
-#  include <map>
-#  include <string>
-#  include <vector>
+#if !FMT_GCC_VERSION || FMT_GCC_VERSION >= 601
+#  define FMT_RANGES_TEST_ENABLE_C_STYLE_ARRAY
+#endif
 
-TEST(RangesTest, FormatVector) {
-  std::vector<int32_t> iv{1, 2, 3, 5, 7, 11};
-  auto ivf = fmt::format("{}", iv);
-  EXPECT_EQ("{1, 2, 3, 5, 7, 11}", ivf);
-}
+#if !FMT_MSC_VER || FMT_MSC_VER > 1910
+#  define FMT_RANGES_TEST_ENABLE_JOIN
+#  define FMT_RANGES_TEST_ENABLE_FORMAT_STRUCT
+#endif
 
-TEST(RangesTest, FormatVector2) {
-  std::vector<std::vector<int32_t>> ivv{{1, 2}, {3, 5}, {7, 11}};
-  auto ivf = fmt::format("{}", ivv);
-  EXPECT_EQ("{{1, 2}, {3, 5}, {7, 11}}", ivf);
+#ifdef FMT_RANGES_TEST_ENABLE_C_STYLE_ARRAY
+TEST(ranges_test, format_array) {
+  int arr[] = {1, 2, 3, 5, 7, 11};
+  EXPECT_EQ(fmt::format("{}", arr), "[1, 2, 3, 5, 7, 11]");
 }
 
-TEST(RangesTest, FormatMap) {
-  std::map<std::string, int32_t> simap{{"one", 1}, {"two", 2}};
-  EXPECT_EQ("{(\"one\", 1), (\"two\", 2)}", fmt::format("{}", simap));
+TEST(ranges_test, format_2d_array) {
+  int arr[][2] = {{1, 2}, {3, 5}, {7, 11}};
+  EXPECT_EQ(fmt::format("{}", arr), "[[1, 2], [3, 5], [7, 11]]");
 }
 
-TEST(RangesTest, FormatPair) {
-  std::pair<int64_t, float> pa1{42, 1.5f};
-  EXPECT_EQ("(42, 1.5)", fmt::format("{}", pa1));
+TEST(ranges_test, format_array_of_literals) {
+  const char* arr[] = {"1234", "abcd"};
+  EXPECT_EQ(fmt::format("{}", arr), "[\"1234\", \"abcd\"]");
 }
+#endif  // FMT_RANGES_TEST_ENABLE_C_STYLE_ARRAY
 
-TEST(RangesTest, FormatTuple) {
-  std::tuple<int64_t, float, std::string, char> t{42, 1.5f, "this is tuple",
-                                                  'i'};
-  EXPECT_EQ("(42, 1.5, \"this is tuple\", 'i')", fmt::format("{}", t));
-  EXPECT_EQ("()", fmt::format("{}", std::tuple<>()));
+TEST(ranges_test, format_vector) {
+  auto v = std::vector<int>{1, 2, 3, 5, 7, 11};
+  EXPECT_EQ(fmt::format("{}", v), "[1, 2, 3, 5, 7, 11]");
 }
 
-TEST(RangesTest, JoinTuple) {
-  // Value tuple args
-  std::tuple<char, int, float> t1 = std::make_tuple('a', 1, 2.0f);
-  EXPECT_EQ("(a, 1, 2.0)", fmt::format("({})", fmt::join(t1, ", ")));
+TEST(ranges_test, format_vector2) {
+  auto v = std::vector<std::vector<int>>{{1, 2}, {3, 5}, {7, 11}};
+  EXPECT_EQ(fmt::format("{}", v), "[[1, 2], [3, 5], [7, 11]]");
+}
 
-  // Testing lvalue tuple args
-  int x = 4;
-  std::tuple<char, int&> t2{'b', x};
-  EXPECT_EQ("b + 4", fmt::format("{}", fmt::join(t2, " + ")));
+TEST(ranges_test, format_map) {
+  auto m = std::map<std::string, int>{{"one", 1}, {"two", 2}};
+  EXPECT_EQ(fmt::format("{}", m), "{\"one\": 1, \"two\": 2}");
+}
 
-  // Empty tuple
-  std::tuple<> t3;
-  EXPECT_EQ("", fmt::format("{}", fmt::join(t3, "|")));
+TEST(ranges_test, format_set) {
+  EXPECT_EQ(fmt::format("{}", std::set<std::string>{"one", "two"}),
+            "{\"one\", \"two\"}");
+}
 
-  // Single element tuple
-  std::tuple<float> t4{4.0f};
-  EXPECT_EQ("4.0", fmt::format("{}", fmt::join(t4, "/")));
+TEST(ranges_test, format_pair) {
+  auto p = std::pair<int, float>(42, 1.5f);
+  EXPECT_EQ(fmt::format("{}", p), "(42, 1.5)");
 }
 
-TEST(RangesTest, JoinInitializerList) {
-  EXPECT_EQ("1, 2, 3", fmt::format("{}", fmt::join({1, 2, 3}, ", ")));
-  EXPECT_EQ("fmt rocks !",
-            fmt::format("{}", fmt::join({"fmt", "rocks", "!"}, " ")));
+TEST(ranges_test, format_tuple) {
+  auto t =
+      std::tuple<int, float, std::string, char>(42, 1.5f, "this is tuple", 'i');
+  EXPECT_EQ(fmt::format("{}", t), "(42, 1.5, \"this is tuple\", 'i')");
+  EXPECT_EQ(fmt::format("{}", std::tuple<>()), "()");
 }
 
-struct my_struct {
-  int32_t i;
-  std::string str;  // can throw
-  template <size_t N> decltype(auto) get() const noexcept {
-    if constexpr (N == 0)
-      return i;
-    else if constexpr (N == 1)
-      return fmt::string_view{str};
+#ifdef FMT_RANGES_TEST_ENABLE_FORMAT_STRUCT
+struct tuple_like {
+  int i;
+  std::string str;
+
+  template <size_t N> fmt::enable_if_t<N == 0, int> get() const noexcept {
+    return i;
+  }
+  template <size_t N>
+  fmt::enable_if_t<N == 1, fmt::string_view> get() const noexcept {
+    return str;
   }
 };
 
-template <size_t N> decltype(auto) get(const my_struct& s) noexcept {
-  return s.get<N>();
+template <size_t N>
+auto get(const tuple_like& t) noexcept -> decltype(t.get<N>()) {
+  return t.get<N>();
 }
 
 namespace std {
+template <>
+struct tuple_size<tuple_like> : std::integral_constant<size_t, 2> {};
 
-template <> struct tuple_size<my_struct> : std::integral_constant<size_t, 2> {};
-
-template <size_t N> struct tuple_element<N, my_struct> {
-  using type = decltype(std::declval<my_struct>().get<N>());
+template <size_t N> struct tuple_element<N, tuple_like> {
+  using type = decltype(std::declval<tuple_like>().get<N>());
 };
-
 }  // namespace std
 
-TEST(RangesTest, FormatStruct) {
-  my_struct mst{13, "my struct"};
-  EXPECT_EQ("(13, \"my struct\")", fmt::format("{}", mst));
+TEST(ranges_test, format_struct) {
+  auto t = tuple_like{42, "foo"};
+  EXPECT_EQ(fmt::format("{}", t), "(42, \"foo\")");
 }
+#endif  // FMT_RANGES_TEST_ENABLE_FORMAT_STRUCT
 
-TEST(RangesTest, FormatTo) {
+TEST(ranges_test, format_to) {
   char buf[10];
-  auto end = fmt::format_to(buf, "{}", std::vector{1, 2, 3});
+  auto end = fmt::format_to(buf, "{}", std::vector<int>{1, 2, 3});
   *end = '\0';
-  EXPECT_STREQ(buf, "{1, 2, 3}");
+  EXPECT_STREQ(buf, "[1, 2, 3]");
 }
 
 struct path_like {
@@ -120,13 +123,10 @@ struct path_like {
   operator std::string() const;
 };
 
-TEST(RangesTest, PathLike) {
+TEST(ranges_test, path_like) {
   EXPECT_FALSE((fmt::is_range<path_like, char>::value));
 }
 
-#endif  // (__cplusplus > 201402L) || (defined(_MSVC_LANG) && _MSVC_LANG >
-        // 201402L && _MSC_VER >= 1910)
-
 #ifdef FMT_USE_STRING_VIEW
 struct string_like {
   const char* begin();
@@ -135,21 +135,229 @@ struct string_like {
   explicit operator std::string_view() const { return "foo"; }
 };
 
-TEST(RangesTest, FormatStringLike) {
-  EXPECT_EQ("foo", fmt::format("{}", string_like()));
+TEST(ranges_test, format_string_like) {
+  EXPECT_EQ(fmt::format("{}", string_like()), "foo");
 }
 #endif  // FMT_USE_STRING_VIEW
 
+// A range that provides non-const only begin()/end() to test fmt::join handles
+// that.
+//
+// Some ranges (e.g. those produced by range-v3's views::filter()) can cache
+// information during iteration so they only provide non-const begin()/end().
+template <typename T> class non_const_only_range {
+ private:
+  std::vector<T> vec;
+
+ public:
+  using const_iterator = typename ::std::vector<T>::const_iterator;
+
+  template <typename... Args>
+  explicit non_const_only_range(Args&&... args)
+      : vec(std::forward<Args>(args)...) {}
+
+  const_iterator begin() { return vec.begin(); }
+  const_iterator end() { return vec.end(); }
+};
+
+template <typename T> class noncopyable_range {
+ private:
+  std::vector<T> vec;
+
+ public:
+  using const_iterator = typename ::std::vector<T>::const_iterator;
+
+  template <typename... Args>
+  explicit noncopyable_range(Args&&... args)
+      : vec(std::forward<Args>(args)...) {}
+
+  noncopyable_range(noncopyable_range const&) = delete;
+  noncopyable_range(noncopyable_range&) = delete;
+
+  const_iterator begin() const { return vec.begin(); }
+  const_iterator end() const { return vec.end(); }
+};
+
+TEST(ranges_test, range) {
+  noncopyable_range<int> w(3u, 0);
+  EXPECT_EQ(fmt::format("{}", w), "[0, 0, 0]");
+  EXPECT_EQ(fmt::format("{}", noncopyable_range<int>(3u, 0)), "[0, 0, 0]");
+
+  non_const_only_range<int> x(3u, 0);
+  EXPECT_EQ(fmt::format("{}", x), "[0, 0, 0]");
+  EXPECT_EQ(fmt::format("{}", non_const_only_range<int>(3u, 0)), "[0, 0, 0]");
+
+  auto y = std::vector<int>(3u, 0);
+  EXPECT_EQ(fmt::format("{}", y), "[0, 0, 0]");
+  EXPECT_EQ(fmt::format("{}", std::vector<int>(3u, 0)), "[0, 0, 0]");
+
+  const auto z = std::vector<int>(3u, 0);
+  EXPECT_EQ(fmt::format("{}", z), "[0, 0, 0]");
+}
+
+enum test_enum { foo };
+
+TEST(ranges_test, enum_range) {
+  auto v = std::vector<test_enum>{test_enum::foo};
+  EXPECT_EQ(fmt::format("{}", v), "[0]");
+}
+
+#if !FMT_MSC_VER
+struct unformattable {};
+
+TEST(ranges_test, unformattable_range) {
+  EXPECT_FALSE((fmt::has_formatter<std::vector<unformattable>,
+                                   fmt::format_context>::value));
+}
+#endif
+
+#ifdef FMT_RANGES_TEST_ENABLE_JOIN
+TEST(ranges_test, join_tuple) {
+  // Value tuple args.
+  auto t1 = std::tuple<char, int, float>('a', 1, 2.0f);
+  EXPECT_EQ(fmt::format("({})", fmt::join(t1, ", ")), "(a, 1, 2)");
+
+  // Testing lvalue tuple args.
+  int x = 4;
+  auto t2 = std::tuple<char, int&>('b', x);
+  EXPECT_EQ(fmt::format("{}", fmt::join(t2, " + ")), "b + 4");
+
+  // Empty tuple.
+  auto t3 = std::tuple<>();
+  EXPECT_EQ(fmt::format("{}", fmt::join(t3, "|")), "");
+
+  // Single element tuple.
+  auto t4 = std::tuple<float>(4.0f);
+  EXPECT_EQ(fmt::format("{}", fmt::join(t4, "/")), "4");
+
+#  if FMT_TUPLE_JOIN_SPECIFIERS
+  // Specs applied to each element.
+  auto t5 = std::tuple<int, int, long>(-3, 100, 1);
+  EXPECT_EQ(fmt::format("{:+03}", fmt::join(t5, ", ")), "-03, +100, +01");
+
+  auto t6 = std::tuple<float, double, long double>(3, 3.14, 3.1415);
+  EXPECT_EQ(fmt::format("{:5.5f}", fmt::join(t6, ", ")),
+            "3.00000, 3.14000, 3.14150");
+
+  // Testing lvalue tuple args.
+  int y = -1;
+  auto t7 = std::tuple<int, int&, const int&>(3, y, y);
+  EXPECT_EQ(fmt::format("{:03}", fmt::join(t7, ", ")), "003, -01, -01");
+#  endif
+}
+
+TEST(ranges_test, join_initializer_list) {
+  EXPECT_EQ(fmt::format("{}", fmt::join({1, 2, 3}, ", ")), "1, 2, 3");
+  EXPECT_EQ(fmt::format("{}", fmt::join({"fmt", "rocks", "!"}, " ")),
+            "fmt rocks !");
+}
+
 struct zstring_sentinel {};
+
 bool operator==(const char* p, zstring_sentinel) { return *p == '\0'; }
 bool operator!=(const char* p, zstring_sentinel) { return *p != '\0'; }
+
 struct zstring {
   const char* p;
   const char* begin() const { return p; }
   zstring_sentinel end() const { return {}; }
 };
-TEST(RangesTest, JoinSentinel) {
-  zstring hello{"hello"};
-  EXPECT_EQ("{'h', 'e', 'l', 'l', 'o'}", fmt::format("{}", hello));
-  EXPECT_EQ("h_e_l_l_o", fmt::format("{}", fmt::join(hello, "_")));
+
+#  ifdef __cpp_lib_ranges
+struct cpp20_only_range {
+  struct iterator {
+    int val = 0;
+
+    using value_type = int;
+    using difference_type = std::ptrdiff_t;
+    using iterator_concept = std::input_iterator_tag;
+
+    iterator() = default;
+    iterator(int i) : val(i) {}
+    int operator*() const { return val; }
+    iterator& operator++() {
+      ++val;
+      return *this;
+    }
+    void operator++(int) { ++*this; }
+    bool operator==(const iterator& rhs) const { return val == rhs.val; }
+  };
+
+  int lo;
+  int hi;
+
+  iterator begin() const { return iterator(lo); }
+  iterator end() const { return iterator(hi); }
+};
+
+static_assert(std::input_iterator<cpp20_only_range::iterator>);
+#  endif
+
+TEST(ranges_test, join_sentinel) {
+  auto hello = zstring{"hello"};
+  EXPECT_EQ(fmt::format("{}", hello), "['h', 'e', 'l', 'l', 'o']");
+  EXPECT_EQ(fmt::format("{}", fmt::join(hello, "_")), "h_e_l_l_o");
+}
+
+TEST(ranges_test, join_range) {
+  noncopyable_range<int> w(3u, 0);
+  EXPECT_EQ(fmt::format("{}", fmt::join(w, ",")), "0,0,0");
+  EXPECT_EQ(fmt::format("{}", fmt::join(noncopyable_range<int>(3u, 0), ",")),
+            "0,0,0");
+
+  non_const_only_range<int> x(3u, 0);
+  EXPECT_EQ(fmt::format("{}", fmt::join(x, ",")), "0,0,0");
+  EXPECT_EQ(fmt::format("{}", fmt::join(non_const_only_range<int>(3u, 0), ",")),
+            "0,0,0");
+
+  auto y = std::vector<int>(3u, 0);
+  EXPECT_EQ(fmt::format("{}", fmt::join(y, ",")), "0,0,0");
+  EXPECT_EQ(fmt::format("{}", fmt::join(std::vector<int>(3u, 0), ",")),
+            "0,0,0");
+
+  const auto z = std::vector<int>(3u, 0);
+  EXPECT_EQ(fmt::format("{}", fmt::join(z, ",")), "0,0,0");
+
+#  ifdef __cpp_lib_ranges
+  EXPECT_EQ(fmt::format("{}", cpp20_only_range{.lo = 0, .hi = 5}),
+            "[0, 1, 2, 3, 4]");
+  EXPECT_EQ(
+      fmt::format("{}", fmt::join(cpp20_only_range{.lo = 0, .hi = 5}, ",")),
+      "0,1,2,3,4");
+#  endif
+}
+#endif  // FMT_RANGES_TEST_ENABLE_JOIN
+
+TEST(ranges_test, is_printable) {
+  using fmt::detail::is_printable;
+  EXPECT_TRUE(is_printable(0x0323));
+  EXPECT_FALSE(is_printable(0x0378));
+  EXPECT_FALSE(is_printable(0x110000));
+}
+
+TEST(ranges_test, escape_string) {
+  using vec = std::vector<std::string>;
+  EXPECT_EQ(fmt::format("{}", vec{"\n\r\t\"\\"}), "[\"\\n\\r\\t\\\"\\\\\"]");
+  EXPECT_EQ(fmt::format("{}", vec{"\x07"}), "[\"\\x07\"]");
+  EXPECT_EQ(fmt::format("{}", vec{"\x7f"}), "[\"\\x7f\"]");
+  EXPECT_EQ(fmt::format("{}", vec{"n\xcc\x83"}), "[\"n\xcc\x83\"]");
+
+  if (fmt::detail::is_utf8()) {
+    EXPECT_EQ(fmt::format("{}", vec{"\xcd\xb8"}), "[\"\\u0378\"]");
+    // Unassigned Unicode code points.
+    EXPECT_EQ(fmt::format("{}", vec{"\xf0\xaa\x9b\x9e"}), "[\"\\U0002a6de\"]");
+    EXPECT_EQ(fmt::format("{}", vec{"\xf4\x8f\xbf\xc0"}),
+              "[\"\\xf4\\x8f\\xbf\\xc0\"]");
+  }
+}
+
+#ifdef FMT_USE_STRING_VIEW
+struct convertible_to_string_view {
+  operator std::string_view() const { return "foo"; }
+};
+
+TEST(ranges_test, escape_convertible_to_string_view) {
+  EXPECT_EQ(fmt::format("{}", std::vector<convertible_to_string_view>(1)),
+            "[\"foo\"]");
 }
+#endif  // FMT_USE_STRING_VIEW
diff --git a/external/fmt/test/scan-test.cc b/external/fmt/test/scan-test.cc
index 962de54c..7e327ea3 100644
--- a/external/fmt/test/scan-test.cc
+++ b/external/fmt/test/scan-test.cc
@@ -11,25 +11,25 @@
 
 #include <climits>
 
-#include "gmock.h"
+#include "gmock/gmock.h"
 #include "gtest-extra.h"
 
-TEST(ScanTest, ReadText) {
-  fmt::string_view s = "foo";
+TEST(scan_test, read_text) {
+  auto s = fmt::string_view("foo");
   auto end = fmt::scan(s, "foo");
   EXPECT_EQ(end, s.end());
   EXPECT_THROW_MSG(fmt::scan("fob", "foo"), fmt::format_error, "invalid input");
 }
 
-TEST(ScanTest, ReadInt) {
-  int n = 0;
+TEST(scan_test, read_int) {
+  auto n = int();
   fmt::scan("42", "{}", n);
   EXPECT_EQ(n, 42);
   fmt::scan("-42", "{}", n);
   EXPECT_EQ(n, -42);
 }
 
-TEST(ScanTest, ReadLongLong) {
+TEST(scan_test, read_longlong) {
   long long n = 0;
   fmt::scan("42", "{}", n);
   EXPECT_EQ(n, 42);
@@ -37,15 +37,15 @@ TEST(ScanTest, ReadLongLong) {
   EXPECT_EQ(n, -42);
 }
 
-TEST(ScanTest, ReadUInt) {
-  unsigned n = 0;
+TEST(scan_test, read_uint) {
+  auto n = unsigned();
   fmt::scan("42", "{}", n);
   EXPECT_EQ(n, 42);
   EXPECT_THROW_MSG(fmt::scan("-42", "{}", n), fmt::format_error,
                    "invalid input");
 }
 
-TEST(ScanTest, ReadULongLong) {
+TEST(scan_test, read_ulonglong) {
   unsigned long long n = 0;
   fmt::scan("42", "{}", n);
   EXPECT_EQ(n, 42);
@@ -53,14 +53,14 @@ TEST(ScanTest, ReadULongLong) {
                    "invalid input");
 }
 
-TEST(ScanTest, ReadString) {
-  std::string s;
+TEST(scan_test, read_string) {
+  auto s = std::string();
   fmt::scan("foo", "{}", s);
   EXPECT_EQ(s, "foo");
 }
 
-TEST(ScanTest, ReadStringView) {
-  fmt::string_view s;
+TEST(scan_test, read_string_view) {
+  auto s = fmt::string_view();
   fmt::scan("foo", "{}", s);
   EXPECT_EQ(s, "foo");
 }
@@ -90,8 +90,8 @@ template <> struct scanner<tm> {
 };
 }  // namespace fmt
 
-TEST(ScanTest, ReadCustom) {
-  const char* input = "Date: 1985-10-25";
+TEST(scan_test, read_custom) {
+  auto input = "Date: 1985-10-25";
   auto t = tm();
   fmt::scan(input, "Date: {0:%Y-%m-%d}", t);
   EXPECT_EQ(t.tm_year, 85);
@@ -100,16 +100,16 @@ TEST(ScanTest, ReadCustom) {
 }
 #endif
 
-TEST(ScanTest, InvalidFormat) {
+TEST(scan_test, invalid_format) {
   EXPECT_THROW_MSG(fmt::scan("", "{}"), fmt::format_error,
                    "argument index out of range");
   EXPECT_THROW_MSG(fmt::scan("", "{"), fmt::format_error,
                    "invalid format string");
 }
 
-TEST(ScanTest, Example) {
-  std::string key;
-  int value;
+TEST(scan_test, example) {
+  auto key = std::string();
+  auto value = int();
   fmt::scan("answer = 42", "{} = {}", key, value);
   EXPECT_EQ(key, "answer");
   EXPECT_EQ(value, 42);
diff --git a/external/fmt/test/scan.h b/external/fmt/test/scan.h
index de82067a..41748ae8 100644
--- a/external/fmt/test/scan.h
+++ b/external/fmt/test/scan.h
@@ -169,13 +169,16 @@ struct scan_handler : error_handler {
     scan_ctx_.advance_to(it + size);
   }
 
-  int on_arg_id() { return on_arg_id(next_arg_id_++); }
-  int on_arg_id(int id) {
+  FMT_CONSTEXPR int on_arg_id() { return on_arg_id(next_arg_id_++); }
+  FMT_CONSTEXPR int on_arg_id(int id) {
     if (id >= args_.size) on_error("argument index out of range");
     arg_ = args_.data[id];
     return id;
   }
-  int on_arg_id(string_view) { return on_error("invalid format"), 0; }
+  FMT_CONSTEXPR int on_arg_id(string_view id) {
+    if (id.data()) on_error("invalid format");
+    return 0;
+  }
 
   void on_replacement_field(int, const char*) {
     auto it = scan_ctx_.begin(), end = scan_ctx_.end();
diff --git a/external/fmt/test/static-export-test/CMakeLists.txt b/external/fmt/test/static-export-test/CMakeLists.txt
new file mode 100644
index 00000000..7690d7b5
--- /dev/null
+++ b/external/fmt/test/static-export-test/CMakeLists.txt
@@ -0,0 +1,30 @@
+cmake_minimum_required(VERSION 3.1...3.18)
+
+project(fmt-link CXX)
+
+set(BUILD_SHARED_LIBS OFF)
+set(CMAKE_VISIBILITY_INLINES_HIDDEN TRUE)
+set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
+
+# Broken LTO on GCC 4
+if (CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
+  set(BROKEN_LTO ON)
+endif ()
+
+if (NOT BROKEN_LTO AND CMAKE_VERSION VERSION_GREATER "3.8")
+  # CMake 3.9+
+  include(CheckIPOSupported)
+  check_ipo_supported(RESULT HAVE_IPO)
+  if (HAVE_IPO)
+    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
+  endif ()
+endif ()
+
+add_subdirectory(../.. fmt)
+set_property(TARGET fmt PROPERTY POSITION_INDEPENDENT_CODE ON)
+
+add_library(library-test SHARED library.cc)
+target_link_libraries(library-test PRIVATE fmt::fmt)
+
+add_executable(exe-test main.cc)
+target_link_libraries(exe-test PRIVATE library-test)
diff --git a/external/fmt/test/static-export-test/library.cc b/external/fmt/test/static-export-test/library.cc
new file mode 100644
index 00000000..fe4801ba
--- /dev/null
+++ b/external/fmt/test/static-export-test/library.cc
@@ -0,0 +1,5 @@
+#include <fmt/compile.h>
+
+__attribute__((visibility("default"))) std::string foo() {
+  return fmt::format(FMT_COMPILE("foo bar {}"), 4242);
+}
diff --git a/external/fmt/test/static-export-test/main.cc b/external/fmt/test/static-export-test/main.cc
new file mode 100644
index 00000000..38f7999e
--- /dev/null
+++ b/external/fmt/test/static-export-test/main.cc
@@ -0,0 +1,6 @@
+#include <iostream>
+#include <string>
+
+extern std::string foo();
+
+int main() { std::cout << foo() << std::endl; }
diff --git a/external/fmt/test/test-assert.h b/external/fmt/test/test-assert.h
index f613722f..ab7b2bf7 100644
--- a/external/fmt/test/test-assert.h
+++ b/external/fmt/test/test-assert.h
@@ -10,7 +10,11 @@
 
 #include <stdexcept>
 
-#include "gtest.h"
+void throw_assertion_failure(const char* message);
+#define FMT_ASSERT(condition, message) \
+  if (!(condition)) throw_assertion_failure(message);
+
+#include "gtest/gtest.h"
 
 class assertion_failure : public std::logic_error {
  public:
@@ -22,8 +26,11 @@ class assertion_failure : public std::logic_error {
 
 void assertion_failure::avoid_weak_vtable() {}
 
-#define FMT_ASSERT(condition, message) \
-  if (!(condition)) throw assertion_failure(message);
+// We use a separate function (rather than throw directly from FMT_ASSERT) to
+// avoid GCC's -Wterminate warning when FMT_ASSERT is used in a destructor.
+inline void throw_assertion_failure(const char* message) {
+  throw assertion_failure(message);
+}
 
 // Expects an assertion failure.
 #define EXPECT_ASSERT(stmt, message) \
diff --git a/external/fmt/test/test-main.cc b/external/fmt/test/test-main.cc
index 8db257d6..268ed086 100644
--- a/external/fmt/test/test-main.cc
+++ b/external/fmt/test/test-main.cc
@@ -7,7 +7,7 @@
 
 #include <cstdlib>
 
-#include "gtest.h"
+#include "gtest/gtest.h"
 
 #ifdef _WIN32
 #  include <windows.h>
@@ -35,6 +35,7 @@ int main(int argc, char** argv) {
   _CrtSetReportFile(_CRT_ASSERT, _CRTDBG_FILE_STDERR);
   try {
     testing::InitGoogleTest(&argc, argv);
+    testing::FLAGS_gtest_death_test_style = "threadsafe";
     return RUN_ALL_TESTS();
   } catch (...) {
     // Catch all exceptions to make Coverity happy.
diff --git a/external/fmt/test/unicode-test.cc b/external/fmt/test/unicode-test.cc
new file mode 100644
index 00000000..63c828dd
--- /dev/null
+++ b/external/fmt/test/unicode-test.cc
@@ -0,0 +1,48 @@
+// Formatting library for C++ - Unicode tests
+//
+// Copyright (c) 2012 - present, Victor Zverovich
+// All rights reserved.
+//
+// For the license information refer to format.h.
+
+#include <iomanip>
+#include <locale>
+#include <vector>
+
+#include "fmt/chrono.h"
+#include "gmock/gmock.h"
+#include "util.h"  // get_locale
+
+using testing::Contains;
+
+TEST(unicode_test, is_utf8) { EXPECT_TRUE(fmt::detail::is_utf8()); }
+
+TEST(unicode_test, legacy_locale) {
+  auto loc = get_locale("ru_RU.CP1251", "Russian_Russia.1251");
+  if (loc == std::locale::classic()) return;
+
+  auto s = std::string();
+  try {
+    s = fmt::format(loc, "День недели: {:L}", fmt::weekday(1));
+  } catch (const fmt::format_error& e) {
+    // Formatting can fail due to an unsupported encoding.
+    fmt::print("Format error: {}\n", e.what());
+    return;
+  }
+
+#if !FMT_GCC_VERSION || FMT_GCC_VERSION >= 500
+  auto&& os = std::ostringstream();
+  os.imbue(loc);
+  auto tm = std::tm();
+  tm.tm_wday = 1;
+  os << std::put_time(&tm, "%a");
+  auto wd = os.str();
+  if (wd == "??") {
+    EXPECT_EQ(s, "День недели: ??");
+    fmt::print("std::locale gives ?? as a weekday.\n");
+    return;
+  }
+#endif
+  EXPECT_THAT((std::vector<std::string>{"День недели: пн", "День недели: Пн"}),
+              Contains(s));
+}
diff --git a/external/fmt/test/util.cc b/external/fmt/test/util.cc
index d08dcbdc..f4cb74ca 100644
--- a/external/fmt/test/util.cc
+++ b/external/fmt/test/util.cc
@@ -9,42 +9,38 @@
 
 #include <cstring>
 
-void increment(char* s) {
-  for (int i = static_cast<int>(std::strlen(s)) - 1; i >= 0; --i) {
-    if (s[i] != '9') {
-      ++s[i];
-      break;
-    }
-    s[i] = '0';
-  }
-}
-
-std::string get_system_error(int error_code) {
-#if defined(__MINGW32__) || !defined(_WIN32)
-  return strerror(error_code);
-#else
-  enum { BUFFER_SIZE = 200 };
-  char buffer[BUFFER_SIZE];
-  if (strerror_s(buffer, BUFFER_SIZE, error_code))
-    throw std::exception("strerror_s failed");
-  return buffer;
-#endif
-}
-
-const char* const FILE_CONTENT = "Don't panic!";
+const char* const file_content = "Don't panic!";
 
 fmt::buffered_file open_buffered_file(FILE** fp) {
 #if FMT_USE_FCNTL
   fmt::file read_end, write_end;
   fmt::file::pipe(read_end, write_end);
-  write_end.write(FILE_CONTENT, std::strlen(FILE_CONTENT));
+  write_end.write(file_content, std::strlen(file_content));
   write_end.close();
   fmt::buffered_file f = read_end.fdopen("r");
   if (fp) *fp = f.get();
 #else
   fmt::buffered_file f("test-file", "w");
-  fputs(FILE_CONTENT, f.get());
+  fputs(file_content, f.get());
   if (fp) *fp = f.get();
 #endif
   return f;
 }
+
+std::locale do_get_locale(const char* name) {
+  try {
+    return std::locale(name);
+  } catch (const std::runtime_error&) {
+  }
+  return std::locale::classic();
+}
+
+std::locale get_locale(const char* name, const char* alt_name) {
+  auto loc = do_get_locale(name);
+  if (loc == std::locale::classic() && alt_name) {
+    loc = do_get_locale(alt_name);
+  }
+  if (loc == std::locale::classic())
+    fmt::print(stderr, "{} locale is missing.\n", name);
+  return loc;
+}
diff --git a/external/fmt/test/util.h b/external/fmt/test/util.h
index 24a5f4e3..2e58ad95 100644
--- a/external/fmt/test/util.h
+++ b/external/fmt/test/util.h
@@ -7,11 +7,14 @@
 
 #include <cstdarg>
 #include <cstdio>
+#include <locale>
 #include <string>
 
-#include "fmt/os.h"
-
-enum { BUFFER_SIZE = 256 };
+#ifdef FMT_MODULE_TEST
+import fmt;
+#else
+#  include "fmt/os.h"
+#endif  // FMT_MODULE_TEST
 
 #ifdef _MSC_VER
 #  define FMT_VSNPRINTF vsprintf_s
@@ -27,12 +30,7 @@ void safe_sprintf(char (&buffer)[SIZE], const char* format, ...) {
   va_end(args);
 }
 
-// Increment a number in a string.
-void increment(char* s);
-
-std::string get_system_error(int error_code);
-
-extern const char* const FILE_CONTENT;
+extern const char* const file_content;
 
 // Opens a buffered file for reading.
 fmt::buffered_file open_buffered_file(FILE** fp = nullptr);
@@ -40,7 +38,7 @@ fmt::buffered_file open_buffered_file(FILE** fp = nullptr);
 inline FILE* safe_fopen(const char* filename, const char* mode) {
 #if defined(_WIN32) && !defined(__MINGW32__)
   // Fix MSVC warning about "unsafe" fopen.
-  FILE* f = 0;
+  FILE* f = nullptr;
   errno = fopen_s(&f, filename, mode);
   return f;
 #else
@@ -48,37 +46,40 @@ inline FILE* safe_fopen(const char* filename, const char* mode) {
 #endif
 }
 
-template <typename Char> class BasicTestString {
+template <typename Char> class basic_test_string {
  private:
   std::basic_string<Char> value_;
 
-  static const Char EMPTY[];
+  static const Char empty[];
 
  public:
-  explicit BasicTestString(const Char* value = EMPTY) : value_(value) {}
+  explicit basic_test_string(const Char* value = empty) : value_(value) {}
 
   const std::basic_string<Char>& value() const { return value_; }
 };
 
-template <typename Char> const Char BasicTestString<Char>::EMPTY[] = {0};
+template <typename Char> const Char basic_test_string<Char>::empty[] = {0};
 
-typedef BasicTestString<char> TestString;
-typedef BasicTestString<wchar_t> TestWString;
+typedef basic_test_string<char> test_string;
+typedef basic_test_string<wchar_t> test_wstring;
 
 template <typename Char>
 std::basic_ostream<Char>& operator<<(std::basic_ostream<Char>& os,
-                                     const BasicTestString<Char>& s) {
+                                     const basic_test_string<Char>& s) {
   os << s.value();
   return os;
 }
 
-class Date {
+class date {
   int year_, month_, day_;
 
  public:
-  Date(int year, int month, int day) : year_(year), month_(month), day_(day) {}
+  date(int year, int month, int day) : year_(year), month_(month), day_(day) {}
 
   int year() const { return year_; }
   int month() const { return month_; }
   int day() const { return day_; }
 };
+
+// Returns a locale with the given name if available or classic locale othewise.
+std::locale get_locale(const char* name, const char* alt_name = nullptr);
